// MARK: Now Playing

markup.push({
	 
	"NowPlayingBubble": {
		nsClass: "Farrago.FGNowPlayingBubbleView",
		gxAutoLoadConstraints: true,
		gxValueKeyPath: "",
		axIsIgnored: false,
		axRoleDescription: "Now Playing",
		axTitleKeyPath: "title",
		selectable: true,
		drawsSelected: true,
		gxIntrinsicWidth: -1,
		gxIntrinsicHeight: -1,
		gxShowSpeedSeconds: 0.1,
		gxHideSpeedSeconds: 0.1,  
		gxWantsLayer: true,
		gxChildViews: {
			"layerView" : {
				nsClass: "GXLayerHostingView",
				gxLayout: [
					"H:|-2-[self(>=50@400)]-2-|",
					"V:|-1-[self]-1-|", 
				],
				gxValueKeyPath: "",  
				gxRootLayer: {
					nsClass: "GXDrawLayer", 
					gxNeedsDisplayOnResize: false, 
					gxSublayers: {
						backLayer: makeBubbleLayers({ foreground: false }), // Built with function
						foreLayer: makeBubbleLayers({ foreground: true }), // Built with function
					}
				}
			}
		}
	}
});

function makeBubbleLayers({ foreground }) { 

	let fillColor = MainThemeColor(Colors.white, Colors.white); 
	return {
		nsClass: "GXDrawLayer",   
		gxLayout: [
			"H:|-2-[self(>=5)]-2-|",
			"V:|-0-[self(>=10)]-0-|",	  
		],
		gxValueKeyPath: "",                         // receive update for tint color changes
		gxBackPainter: {
			nsClass: "GXRoundRectPainter",
			gxCornerRadius: 10, 
			gxDefaultSize: "16,16",        // the size of content image 
			gxFillColor: foreground ? Colors.tileTint : MainThemeColor(Colors.tileTint.withAlpha(0.5), Colors.tileTint.withAlpha(0.5)),
			gxFrameColor: Colors.contrast,
			gxStrokeWidth: 1,
		},   
		gxLayerZPosition: foreground ? 20 : 10,
		gxSublayers: {
			 
			[`icon${foreground ? "Fore" : "Back"}`]: ImageLayer("now-playing-left",fillColor)
				.keyPath(""), 
			  

			[`title${foreground ? "Fore" : "Back"}Small`]: Layer("GXStringLayer")
				.forePainter(
					LabelPainter()
						.color(fillColor)
						.align(0,0.5)
						.fontSize(13)
						.weight(0.2)
				)
				.keyPath("titleWithEmoji")
				.intrinsicSize(-1, -1)  
				.addLayout(`H:[self(<=${Constants.maxBubbleTitleWidth})]`)
				.leftPad(20)
				.addLayout("H:[self(>=1000@750)]-(>=60@700)-|")
				.addLayout("H:[self(>=40@750)]-(>=10)-|")
				.fillWidth()
				.fillHeight(),

			[`title${foreground ? "Fore" : "Back"}Big`]: Layer("GXStringLayer")
				.forePainter(
					LabelPainter()
						.color(fillColor)
						.weight(0.2)
						.align(0,0.5)
						.fontSize(15)
				)
				.keyPath("titleWithEmoji")
				.intrinsicSize(-1, -1)  
				.addLayout(`H:[self(<=${Constants.maxBubbleTitleWidth})]`)
				.leftPad(30)
				.addLayout("H:[self(>=1000@750)]-(>=60@700)-|")
				.addLayout("H:[self(>=40@750)]-(>=10)-|")
				.fillWidth()
				.fillHeight(),

			[`readout${foreground ? "Fore" : "Back"}Small`]: Layer("GXStringLayer") 
				.forePainter(
					LabelPainter()
						.align(1,0.5)
						.color(fillColor)
						.fontSize(10)
						.weight(-0.4) 
						.setValues({ 
							gxMonoSpacedDigits: true,
						})
				)    
				.keyPath("remainingPlayingOrPreviewTimeString") 
				.animateKey("playingOrPreviewing"),  

			[`readout${foreground ? "Fore" : "Back"}Big`]: Layer("GXStringLayer") 
				.forePainter(
					LabelPainter()
						.align(1,0.5)
						.color(fillColor)
						.fontSize(12) 
						.setValues({ 
							gxMonoSpacedDigits: true,
						})
				)     
				.keyPath("remainingPlayingOrPreviewTimeString") 
				.animateKey("playingOrPreviewing"),  
				
			[`iconRight${foreground ? "Fore" : "Back"}`]: ImageLayer("now-playing-right",fillColor)
				// .bordered()
				.keyPath(""), 
		}
	};
};