markup.push
({   
    "PasswordCreationWindow" : Window("Create Set Password", VStack([  
        Padding(15),
        HStack([
            Padding(15),
            Label("Create a password for this set").fontSize(13).fontWeight(0.2),
            Spacer(),
        ]),
        Padding(20),
        VStack([
            HStack([
                Padding(20),
                FramedTextField("Password:","security.password", "alignCenterY", "GXPasswordField")
                    .setAXHelp("Create set password")
                    .fillWidth()
                    .height(28)
                    .viewName("passwordField"),
            ]),
            Padding(20),
            HStack([
                Padding(43),
                FramedTextField("Verify:","security.verify", "alignCenterY", "GXPasswordField")
                    .setAXHelp("Verify password")
                    .fillWidth()
                    .height(28)
                    .viewName("validationField"),
            ]),
            Padding(20),
            HStack([
                Padding(54),
                FramedTextField("Hint:","security.hint",labelAlign="alignTop").fillWidth().height(50).viewName("hintField"),
            ]),
        ]).makeView().fillWidth().hPad(15), 
        Padding(),
        HStack([
            Spacer(),
            Label().useInlineMarkup(true).keyPath("passwordEntryGuidance"),
            Padding(15)
        ]),
        Padding(),
        HStack([
            Spacer(), 
            PushButton("Cancel", "Cancel password assignment")
                .toolTip("Cancel password assignment")
                .keyPath("cancelBtn").width(70),
            Padding(),
            PushButton("Set Password")
                .toolTip("Assign password to this set")
                .setAXHelp("Assign password to this set")
                .keyEquivalent("\r")
                .keyPath("okButton").width(110),
            Padding(15),
        ]),
        Padding(15),
        Spacer(),   
    ])
    .background(Color(Colors.mainBackground)) 
    .addLayout("H:[self(400)]").addLayout("V:[self(200@500)]")),

    "PasswordModificationWindow" : Window("Update Password", VStack([  
        Padding(15),
        HStack([
            Padding(15),
            Label("Update the password for this set").fontSize(13).fontWeight(0.2),
            Spacer(),
        ]),
        Padding(15), 
        VStack([
            HStack([
                Padding(27),
                FramedTextField("Old Password:","oldPassword", "alignCenterY", "GXPasswordField")
                    .setAXHelp("To change the password, first enter the old password")
                    .fillWidth()
                    .height(28)
                    .viewName("currentPasswordField"),
            ]), 
            HStack([
                Padding(21),
                FramedTextField("New password:","security.password", "alignCenterY", "GXPasswordField")
                    .setAXHelp("Enter the new password")
                    .fillWidth()
                    .height(28)
                    .viewName("passwordField"),
            ]), 
            HStack([
                Padding(75),
                FramedTextField("Verify:","security.verify", "alignCenterY", "GXPasswordField")
                    .setAXHelp("Verify the new password")
                    .fillWidth()
                    .height(28)
                    .viewName("validationField"),
            ]), 
            HStack([
                Padding(85),
                FramedTextField("Hint:","security.hint",labelAlign="alignTop").fillWidth().height(50).viewName("hintField"),
            ]),
        ],15).makeView().fillWidth().hPad(15), 
        HStack([
            Spacer(),
            Label().useInlineMarkup(true).keyPath("passwordEntryGuidance"),
            Padding(15)
        ]),
        Padding(10),
        HStack([
            Spacer(), 
            PushButton("Cancel", "Cancel password modification")
                .toolTip("Cancel password modification")
                .keyPath("cancelBtn").width(70),
            Padding(),
            PushButton("Change Password")
                .toolTip("Commit password modification")
                .keyEquivalent("\r").keyPath("okButton").width(135),
            Padding(10),
        ]),
        Padding(10),
        Spacer(),   
    ])
    .background(Color(Colors.mainBackground)) 
    .addLayout("H:[self(400)]")
    .addLayout("V:[self(<=0@400)]")),

    "PasswordUnlockWindow" : PasswordUnlockWindow("Unlock Set", "This set is locked", "Enter password to unlock this set:"),
    "PasswordRequiredWindow" : PasswordUnlockWindow("Password Required", "Password required", "To turn off this setting, enter the set's password:"),
});
 
function PasswordUnlockWindow(windowTitle, label1, label2)
{
    return Window(windowTitle, 
        VStack([   
        HStack([
            Image("lock-big", Colors.secondaryContent).size(80),
            VStack([
                Padding(15),
                Label(label1).fontSize(13).fontWeight(0.2),
                Padding(), 
                Label(label2).fontSize(13).fontWeight(0.0), 
                Padding(),
                
                // Password hint prompt
                Label()
                    .ignoreAX()
                    .textPainter(LabelPainter("").color(Colors.secondaryContent).backColor(Colors.invisible))
                    .backPainter(Painter())
                    .keyPath("security.hintFormatted")
                    .className("GXTextView")
                    .setValues({
                        gxResizeHeightToFitContent : true,
                        gxEditable: false,
                        gxSelectable: false,
                        gxTextContainerAlignment: "{-4,0}"
                    }),
                
                FramedTextField("","password", "alignCenterY", "GXPasswordField")
                    .setAXHelp(windowTitle + ". " + label2) 
                    .fillWidth() 
                    .viewName("passwordField"),
                
                Padding(),
                
                HStack([
                    PushButton("Cancel", "Cancel set unlock")
                        .toolTip("Cancel set unlock")
                        .width(70).keyPath("cancelBtn"),
                    Padding(6),
                    PushButton("Unlock", "Cancel set button")
                        .viewName("confirmButton")
                        .toolTip("Unlock the set")
                        .keyEquivalent("\r")
                        .width(70)
                        .keyPath("okButton"),
                ]), 

                Padding(11),  
            ]).align("left"),
            Padding(21),
       ])
    ])
        .makeView()
        .addLayout("V:[self(<=20@500)]")
        // .background(Color(Colors.mainBackground)) 
        .shrinky()
    );
}
